<template>
    <div>
        <v-toolbar flat color="white">
            <v-toolbar-title>{{tableTitle}}</v-toolbar-title>
            <v-spacer></v-spacer>
            <v-dialog v-model="dialog" persistent max-width="600px">
                <template v-slot:activator="{ on }">
                    <v-btn color="primary" dark v-on="on">{{dialogAction}}</v-btn>
                </template>
                <v-card>
                    <v-card-title>
                        <span class="headline">{{dialogAction}}</span>
                    </v-card-title>
                    <v-card-text>
                        <v-container grid-list-md>
                            <v-layout wrap>
                                <v-flex xs12 v-for="(field, key) in modelSchema" :key="key">
                                    <v-text-field v-if="field.type === 'String'" :label="field.name" v-model="editedItem[field.name]"></v-text-field>
                                    <v-switch
                                        v-if="field.type === 'Boolean'"
                                        v-model="editedItem[field.name]"
                                        :label="field.name"
                                    ></v-switch>
                                    <v-textarea
                                        v-if="field.type === 'Text'"
                                        :name="key"
                                        box
                                        :label="field.name"
                                        auto-grow
                                        :value="editedItem[field.name]"
                                    ></v-textarea>
                                </v-flex>
                            </v-layout>
                        </v-container>
                    </v-card-text>
                    <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn color="blue darken-1" flat @click="close">Close</v-btn>
                        <v-btn color="blue darken-1" flat @click="save">Save</v-btn>
                    </v-card-actions>
                </v-card>
            </v-dialog>
        </v-toolbar>
        <div>
            <v-data-table
                :headers="headers"
                :items="responseData"
                :pagination.sync="pagination"
                :total-items="meta.total"
                :loading="loading"
                class="elevation-1"
                :rows-per-page-items="[15,30,50,100,200,{'text':'$vuetify.dataIterator.rowsPerPageAll','value':-1}]"
            >
                <v-progress-linear v-slot:progress color="blue" indeterminate></v-progress-linear>
                <template v-slot:items="props">
                    <td v-for="header in headers">{{ props.item[header.value] }}</td>
                    <td class="justify-center layout px-0">
                        <v-icon
                            small
                            class="mr-2"
                            @click="editItem(props.item)"
                        >
                            edit
                        </v-icon>
                        <v-icon
                            small
                            @click="deleteItem(props.item)"
                        >
                            delete
                        </v-icon>
                    </td>
                </template>
            </v-data-table>
        </div>

    </div>

</template>
<script>
    import helpers from './../../helpers';
    export default {
        data () {
            return {
                model: '',
                modelSchema: {},
                meta: {},
                responseData: [],
                loading: true,
                pagination: {
                },
                headers: [],
                dialog: false,
                editedIndex: -1,
                editedItem: {},
                menu: false
            }
        },
        computed:{
            tableTitle() {
                return this.$route.name.charAt(0).toUpperCase() + this.$route.name.slice(1);
            },
            dialogAction () {
                return this.editedIndex === -1 ? 'New ' +this.$route.name : 'Edit ' + this.$route.name
            }
        },
        watch: {
            pagination: {
                handler () {
                    this.fetchData();
                },
                deep: true
            },
            '$route': function () {;
                this.model = this.$router.currentRoute.path;
                this.getTableStructureAndData();
                this.fetchData();
            }
        },
        created(){
            this.model = this.$router.currentRoute.path;
            this.getTableStructureAndData();
        },
        methods: {
            fetchData: function () {
                this.loading = true;
                const {sortBy, descending, page, rowsPerPage} = this.pagination;
                axios.get(this.model, {
                    params: {
                        sort_by: this.pagination.sortBy,
                        descending: this.pagination.descending,
                        page: this.pagination.page,
                        rows_per_page: this.pagination.rowsPerPage,
                    }
                })
                    .then(response => {
                        this.loading = false;
                        this.meta = response.data.meta;
                        this.pagination.rowsPerPage = response.data.meta.per_page;
                        this.responseData = response.data.data;
                        this.createHeaders();

                    })
                    .catch(error => {
                        this.meta = {};
                        this.responseData = [];
                        this.headers = [];
                        helpers.errorHandler(error);
                    });
            },
            createHeaders() {
                this.headers = [];
                if (this.responseData.lenght <= 0) {
                    return;
                }
                for (let item in this.responseData[0]) {
                    let text = item.charAt(0).toUpperCase() + item.slice(1);
                    this.headers.push({
                        text: text.split('_').join(' '),
                        value: item
                    });
                }
            },
            editItem (item) {
                this.editedIndex = this.responseData.indexOf(item)
                this.editedItem = Object.assign({}, item)
                this.dialog = true
            },

            deleteItem (item) {
                confirm('Are you sure you want to delete this item?') && axios.delete(this.model + '/' + item.id)
                    .then(response => {
                        this.responseData = this.responseData.filter(el => el.id !== response.data.id);
                    })
                    .catch(error => helpers.errorHandler(error));
            },

            close () {
                this.dialog = false
                setTimeout(() => {
                    this.editedItem = Object.assign({}, this.defaultItem)
                    this.editedIndex = -1
                }, 300)
            },

            save () {
                if (this.editedIndex > -1) {
                    this.updateModel();
                } else {
                    this.newModel();
                    this.fetchData();
                }
                this.close()
            },
            getTableStructureAndData: function () {
                axios.get(this.model + '/create')
                    .then(response => {
                        console.log(response);
                        this.modelSchema = response.data.schema;
                        /*this.responseData = response.data;
                        if (response.data.hasOwnProperty('relations')) {
                            this.responseDataRelations = response.data.relations;
                        }
                        */
                    })
                    .catch(error => helpers.errorHandler(error));
            },
            newModel: function () {
                axios.post(this.model, this.editedItem)
                    .then(response => {
                        console.log(response);
                    })
                    .catch((error) => {
                        //this.setValidationErrors(error.response.data.errors);
                        helpers.errorHandler(error);
                    });
            },
            updateModel: function () {

                axios.put(this.model + '/' + this.responseData[this.editedIndex].id, this.editedItem)
                    .then(response => {
                        Object.assign(this.responseData[this.editedIndex], this.editedItem)
                    })
                    .catch((error) => {
                        // this.setValidationErrors(error.response.data.errors);
                        helpers.errorHandler(error);
                    });
            }
        }
    }
</script>
